--Smh add credits indev, thanks for help

freeslot("sfx_uref1")
freeslot("sfx_uref2")
freeslot("sfx_urhow")

freeslot("S_UROTSUKI_HOWL")

local spr = freeslot("SPR_UROW")
local animspr = freeslot("SPR_UTHO")

local anim_frames = 4
local anim_time_per_frame = 13
local anim_time = anim_frames * anim_time_per_frame

local skin = "urotsuki"

local function copyFields(mo, master, fields)
	for _, field in ipairs(fields) do
		mo[field] = master[field]
	end
end

local shadowqueue = {}

-- Thanks mobj interpolation, very cool
local function spawnShadowLater(mo)
	table.insert(shadowqueue, mo)
end

addHook("PreThinkFrame", function()
	while #shadowqueue do
		local mo = table.remove(shadowqueue)
		
		if mo.valid then
			P_SpawnShadowMobj(mo)
		end
	end
end)

local function copyTarget(mo)
	local pmo = mo.target
	copyFields(mo, pmo, {
		"eflags",
		"color",
		"scale",
		"radius",
		"height",
		"spritexscale",
		"spriteyscale",
		"spritexoffset",
		"spriteyoffset",
	})
	mo.angle = pmo.player.frameangle
	mo.rollangle = (pmo.rollsum ~= nil and pmo.rollsum) or pmo.sloperoll
end

function A_UrotsukiHowl(mo)
	if not (mo.target and mo.target.player and mo.target.skin:lower() == skin) then
		P_RemoveMobj(mo)
		return
	end
	
	P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
	copyTarget(mo)

	local t = leveltime - mo.switchsprite_animstart

    local frame = 0

    if not mo.reverseAnimation then
        frame = (t / anim_time_per_frame) % anim_frames
    else
        frame = anim_frames - 1 - (t / anim_time_per_frame) % anim_frames
    end

    mo.frame = frame

    if not mo.reverseAnimation and t >= anim_time then
        S_StartSound(mo.target, sfx_urhow)
        mo.reverseAnimation = true
        mo.switchsprite_animstart = leveltime  -- Reset the timer to reverse
		mo.frame = anim_frames - 1
    elseif mo.reverseAnimation then
        if t >= anim_time then
            mo.target.switchsprite_anim = false
			mo.target.flags2 = $ & ~MF2_DONTDRAW
			mo.flags2 = $ | MF2_DONTDRAW
        end
    end
end

states[S_UROTSUKI_HOWL] = {
	sprite = animspr,
	frame = A,
	tics = 1,
	action = A_UrotsukiHowl,
	nextstate = S_UROTSUKI_HOWL
}

local function playAnimation(p)
	if p.mo.switchsprite_anim then return end
	
	p.mo.switchsprite_anim = true

	if not (p.mo.howlmobj and p.mo.howlmobj.valid) then
		p.mo.howlmobj = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
		p.mo.howlmobj.target = p.mo
		p.mo.howlmobj.radius = p.mo.radius
		spawnShadowLater(p.mo.howlmobj)
	end
	
	copyTarget(p.mo.howlmobj)
	p.mo.howlmobj.switchsprite_animstart = leveltime
	p.mo.howlmobj.reverseAnimation = false
	p.mo.howlmobj.flags2 = $ & ~MF2_DONTDRAW
	
	-- Start animation
	p.mo.howlmobj.state = S_UROTSUKI_HOWL
end

local function playSparks(p)
    for i = 1, 10 do
        local sparks = P_SpawnMobj(p.mo.x + P_RandomRange(-64, 64) * p.mo.scale,
                    p.mo.y + P_RandomRange(-64, 64) * p.mo.scale,
                    p.mo.z + P_RandomRange(64, 0) * p.mo.scale,
                    MT_SPARKLETRAIL)
        sparks.color = SKINCOLOR_WHITE
    end
end

local function updatePlayer(p)
    if not (p.mo and p.mo.skin:lower() == skin:lower()) then return end

    -- Block button presses if animation is active
    if not p.mo.switchsprite_anim then
        if p.cmd.buttons & BT_CUSTOM1 then --Switching
            p.mo.switchsprite_button1 = (p.mo.switchsprite_button1 or 0) + 1
        else
            p.mo.switchsprite_button1 = 0
        end

        if p.cmd.buttons & BT_CUSTOM2 and p.switchsprite then --Howling
            p.mo.switchsprite_button2 = (p.mo.switchsprite_button2 or 0) + 1
        else
            p.mo.switchsprite_button2 = 0
        end

        if p.mo.switchsprite_button1 == 1 then
			playSparks(p)
			if p.switchsprite then
				S_StartSound(p.mo, sfx_uref2)
			else
				S_StartSound(p.mo, sfx_uref1)
			end
            p.switchsprite = not p.switchsprite
        end

        if p.mo.switchsprite_button2 == 1 then
			playAnimation(p)
        end
    else
        p.mo.flags2 = $ | MF2_DONTDRAW
    end
	
	if p.switchsprite then
        p.mo.sprite = spr
    end
end

addHook("ThinkFrame", function()
    for p in players.iterate do
        updatePlayer(p)
    end
end)
